Bug 1012043 - keyctl_get_persistent isn't versioned
keyctl_get_persistent isn't versioned
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: keyutils (Show other bugs)
22
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: David Howells
Fedora Extras Quality Assurance
https://bugzilla.redhat.com/show_bug....
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-25 11:25 EDT by Nalin Dahyabhai
Modified: 2016-07-19 06:26 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-07-19 06:26:28 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Nalin Dahyabhai 2013-09-25 11:25:07 EDT
Description of problem:
While the keyutils library generally uses symbol versioning, the new keyctl_get_persistent function doesn't have a version assigned to it.  This allows package-level dependencies to be satisfied while still allowing people to run into bug #1012034.

Version-Release number of selected component (if applicable):
keyutils-1.5.6-2.fc21

How reproducible:
Always

Steps to Reproduce:
1. eu-readelf -s /usr/lib*/libkeyutils.so

Actual results:
keyctl_get_persistent has no version information.

Expected results:
keyctl_get_persistent is versioned, similar to other global functions.
Comment 1 Nalin Dahyabhai 2013-10-03 13:56:26 EDT
It looks like 1.5.7 tagged it (and find_key_by_type_and_desc) with version KEYUTILS_1.4, which was already present in earlier versions of the package, so I think we're still going to see this problem.
Comment 2 Vít Ondruch 2013-10-04 08:32:12 EDT
This seems to break Ruby build configuration process:

"gcc -o conftest -I../../.ext/include/x86_64-linux -I../.././include -I../.././ext/openssl    -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -mtune=generic -fPIC conftest.c  -L. -L../.. -lssl -lcrypto  -m64   -lruby-static  -lpthread -ldl -lcrypt -lm   -lc"
/lib64/libkrb5.so.3: undefined reference to `keyctl_get_persistent@KEYUTILS_1.4'
collect2: error: ld returned 1 exit status
checked program was:
/* begin */
1: #include "ruby.h"
2: 
3: int main() {return 0;}
/* end */

package configuration for openssl is not found


Could you please fix it or revert?
Comment 3 David Howells 2013-10-04 09:13:50 EDT
(In reply to Nalin Dahyabhai from comment #1)
> It looks like 1.5.7 tagged it (and find_key_by_type_and_desc) with version
> KEYUTILS_1.4, which was already present in earlier versions of the package,
> so I think we're still going to see this problem.

I've altered that to put the two new symbols into KEYUTILS_1.5 and pushed as 1.5.8.
Comment 4 David Howells 2013-10-04 09:27:17 EDT
(In reply to Vít Ondruch from comment #2)
> This seems to break Ruby build configuration process:
> ...
> /lib64/libkrb5.so.3: undefined reference to
> `keyctl_get_persistent@KEYUTILS_1.4'
> ...
> Could you please fix it or revert?

Hmmm...  I've just pushed Nalin's request (ie. I've introduced library version 1.5 to hold the new symbols instead of putting them in 1.4) upstream and built it into Fedora.  I was about to push it into RHEL-7.  I'm not sure what to do at this point.
Comment 5 Nalin Dahyabhai 2013-10-04 09:46:37 EDT
Well, unless you plan on reverting it, anything that has a reference to the new symbols when they were tagged with the incorrect versions needs to be rebuilt so that their shared libraries will match.  I'll push a new krb5 build shortly.
Comment 6 Jaroslav Reznik 2015-03-03 12:10:03 EST
This bug appears to have been reported against 'rawhide' during the Fedora 22 development cycle.
Changing version to '22'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora22
Comment 7 Fedora End Of Life 2016-07-19 06:26:28 EDT
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.